#!/usr/bin/perl -w
#
# Syrup v1.0.0 by ~g/RRR for xchat (atleast v1.2.1 works)
#
# Released (18.Dec.1999) under GNU General Public License.
#
#

$Datafile=$ENV{HOME}."/syrup.lst";

####################################################################

IRC::register("Syrup","1.0.0","","");
IRC::print("Syrup: Initializing... ");
IRC::add_command_handler("syrup", "syrup_start");
IRC::add_command_handler("spush", "syrup_push");
IRC::add_command_handler("slist", "syrup_list");
IRC::add_print_handler("DCC Connected", "syrup_next");
IRC::print("Ready as a sugared radish.\n");
IRC::print("Syrup:\n");
IRC::print("Syrup: /spush <command> pushes commands to the queue.\n");
IRC::print("Syrup: /syrup <nick>    activates Syrup.\n");
IRC::print("Syrup: /slist           lists the current queue contents & status\n");

$Nick=$nothing;
@Commands=();
$Cmdamount=0;
$Cmditer=0;

#
# This function resets the global variables to zero
# state for a new run with different nick and command list.
#
sub syrup_reset
{
	$Nick=$nothing;
	@Commands=();
	$Cmdamount=0;
	$Cmditer=0;
}

#
# Starts Syrup with a new nick, or if old is defined, aborts
# the current action.
#
sub syrup_start
{
	$aline = shift(@_);
	@items = split ' ', $aline;
	$count = @items;
		
	if(!($Nick eq $nothing))
	{
		IRC::print("Syrup: Aborting action with $Nick\n");
		syrup_reset();
		return(1);
	}

	if($count != 1) {
		IRC::print("Usage: /syrup <nick>\n");
		return(1);
	}
	
	$Nick=$items[0];

	#
	# Read the command list file, 1 command per line
	#
	if(open(CMDLIST,$Datafile)) {
		IRC::print("Syrup: Loading '$Datafile'\n");
		while(<CMDLIST>) {
			chop;
			if(!($_ eq "")) {
				push @Commands, ($_);
				$Cmdamount++;
			}	
		}	
		close(CMDLIST);
	}
	else
	{
		if($Cmdamount == 0)
		{
			IRC::print("Syrup: Can't open '$Datafile'\n");
			IRC::print("Syrup: You haven't pushed any commands to the queue with /spush either\n");
			syrup_reset();
			return(1);
		}
	}

	IRC::print("Syrup: Activated for ");
	IRC::print($Nick." ($Cmdamount commands).\n");

	# 
	# Launch first command
	#
	
	syrup_doreq();

	return(1);
}

#
# This function parses the incoming messages. If it seems
# that the message is one that tells that the DCC send
# started from the chosen nick, we blurp out the next
# command.
#
sub syrup_next
{
#	IRC::print("Syrup: syrup_next\n");
	
	$aline = shift(@_);
	@items = split ' ', $aline;

#	IRC::print("Syrup: N: $items[0] $items[1] $items[2]\n");

	if($Nick eq $nothing) {
#		IRC::print("Syrup: Syrup not launched yet\n");
		return(0);
	}
	if($items[0] =~ "SEND") {
#		IRC::print("Syrup: wrong cmd '$items[0]'\n");
		return(0);
	}
	if(!($items[1] eq $Nick)) {
#		IRC::print("Syrup: wrong nick '$items[1]'\n");
		return(0);
	}
	
	#
	# Ok, the last command has succeeded and we got
	# a DCC SEND message from $Nick. Now lets blurp out 
	# our next request.
	#
	
	syrup_doreq();

	return(0);
}

#
# This pushes a new command to the @Command queue
#
sub syrup_push
{
#	IRC::print("Syrup: suryp_push\n");
	
	$aline = shift(@_);

	if($aline eq "")
	{
		IRC::print("Usage: \spush <command>\n");
		return(1);
	}

#	IRC::print("AL: ".$aline."\n");

	push @Commands, $aline;
	$Cmdamount++;

	$cmdleft=$Cmdamount-$Cmditer;
	IRC::print("Syrup: Ok, total $cmdleft commands in list.\n");
	
	return(1);
}

#
# This shows the contents of the current @Command queue
#
sub syrup_list
{
	if($Cmdamount == 0)
	{
		IRC::print("Syrup: Command list is empty. Syrup is stopped.\n");
		return(1);
	}
	
	$printval=$Cmdamount-$Cmditer;
	IRC::print("Syrup: $printval commands left (status: ");

	if($Nick eq $nothing) 
	{
		IRC::print("Stopped).\n");
	}
	else
	{
		IRC::print("Active).\n");
	}

	IRC::print("Syrup:\n");

	$count=$Cmditer;
	while($count < $Cmdamount)
	{
		IRC::print("Syrup: ($count) @Commands[$count]\n");
		$count++;
	}
	
	return(1);
}

#
# This blurps out the next command from the @Command queue
#
sub syrup_doreq
{
	if($Cmditer < $Cmdamount) {
		$printval=$Cmditer+1;
		IRC::print("Syrup: Launching command ($printval/$Cmdamount)...\n");
		IRC::print("Syrup: ".@Commands[$Cmditer]."\n");
		IRC::command(@Commands[$Cmditer]);
		$Cmditer++;
	}

	if($Cmditer == $Cmdamount)
	{
		IRC::print("Syrup: All done, resetting.\n");
		syrup_reset();
	}

	return(0);
}

